// Generated by CoffeeScript 1.9.3

/*
LemonLDAP::NG 2F registration script
 */

(function() {
  var delete2F, displayError, setMsg;

  setMsg = function(msg, level) {
    $('#msg').html(window.translate(msg));
    $('#color').removeClass('message-positive message-warning alert-success alert-warning');
    $('#color').addClass("message-" + level);
    if (level === 'positive') {
      level = 'success';
    }
    return $('#color').addClass("alert-" + level);
  };

  displayError = function(j, status, err) {
    var res;
    console.log('Error', err);
    res = JSON.parse(j.responseText);
    if (res && res.error) {
      res = res.error.replace(/.* /, '');
      console.log('Returned error', res);
      return setMsg(res, 'warning');
    }
  };

  delete2F = function(device, epoch) {
    if (device === 'U2F') {
      device = 'u';
    } else if (device === 'UBK') {
      device = 'yubikey';
    } else if (device === 'TOTP') {
      device = 'totp';
    } else {
      setMsg('u2fFailed', 'warning');
    }
    $("#delete-" + epoch).hide();
    return $.ajax({
      type: "POST",
      url: portal + "2fregisters/" + device + "/delete",
      data: {
        epoch: epoch
      },
      dataType: 'json',
      error: displayError,
      success: function(resp) {
        if (resp.error) {
          return setMsg('notAuthorized', 'warning');
        } else if (resp.result) {
          return setMsg('yourKeyIsUnregistered', 'positive');
        }
      },
      error: displayError
    });
  };

  $(document).ready(function() {
    $('body').on('click', '.btn-danger', function() {
      return delete2F($(this).attr('device'), $(this).attr('epoch'));
    });
    $('#goback').attr('href', portal);
    return $(".data-epoch").each(function() {
      var myDate;
      myDate = new Date($(this).text() * 1000);
      return $(this).text(myDate.toLocaleString());
    });
  });

}).call(this);
